﻿package com.nosuch {
	
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.utils.*;
	
	public class FingerSprite {
		
		var _s:Sprite;
		var _t:String;
		var _pt:Point;
		var _w:Number;
		var _h:Number;
		var _age:uint;
		var _maxage:uint = 300;
		public var angDir:uint = 1;
		public var fid:String;
		
		private var _xController : SpringController;
		private var _yController : SpringController;

		public function FingerSprite(f:String,pt:Point,w:Number,h:Number,t:String):void {
			fid = f;
			var obj:Object = getDefinitionByName(t);
			if ( obj == null ) {
				trace("NO SUCH OBJECT TYPE: ",t);
				_s = null;
			} else {
				_s = new obj();
			}
			_t = t;
			_s.x = pt.x;
			_s.y = pt.y;
			if ( Math.random() < 0.5 )
				angDir = -angDir;
//			_pt = pt;
//			_w = w;
//			_h = h;
			_age = 0;
			// trace("NEW FingerSprite");
//			refresh();
			
			_xController = new SpringController("x");
			_yController = new SpringController("y");
		}
		
		public function get x():Number { return _s.x; }
		public function set x(v:Number):void { _s.x = v; }
		public function get y():Number { return _s.y; }
		public function set y(v:Number):void { _s.y = v; }
		
		public function makeOlder():void {
			_age++;
			// _s.alpha *= 0.9;
		}
		
		public function isTooOld():Boolean {
			return ( _age > _maxage );
		}
		
//		public function refresh():void {
//			if ( _t == "circle" ) {
//				myDrawCircle(_pt.x,_pt.y,_w/2.0);
//			} else {
//				_s.x = _pt.x;
//				_s.y = _pt.y;
//				_s.width = _w;
//				_s.height = _h;
//			}
//		}
		public function resize(w:Number,h:Number) {
			var e:uint = 5.0;
			var neww:Number = ((e-1)*(_s.width) + w)/e;
			var newh:Number = ((e-1)*(_s.height) + h)/e;
//			_s.width = w;
//			_s.height = h;
			_s.width = neww;
			_s.height = newh;
		}
		public function moveTo(pt:Point):void {
			_s.x = pt.x;
			_s.y = pt.y;
			// _pt = pt;
		}
		public function get sprite() {
			return _s;
		}
		public function get age() {
			return _age;
		}
//		public function myDrawCircle(x:Number,y:Number,r:Number):void {
//			_s.graphics.clear()
//			_s.graphics.beginFill(0x0000FF,0.4);
//			// trace("myDrawCircle x=",x," y=",y," r=",r);
//			_s.graphics.drawCircle(x,y,r);
//			// trace("drawCircle at ",x," ",y," ",radius);
//			_s.graphics.endFill();
//        }
		
		public function killMe():void {
			// trace("REMOVEME called");
			_xController.stopSpringing();
			_yController.stopSpringing();
			_age = _maxage + 1;
		}
		public function animateTo(x:Number, y:Number, ease:Number, damp:Number):void {
			// trace("animateTo to ",x," ",y);
			var springData:SpringData;
			springData = new SpringData();
			springData.itemList = [_s];
			springData.myEasing = ease;
			springData.myDamping = damp;
			springData.startValue = null;
			springData.endValue = [x];
			springData.minSpeed = 0.1;
			springData.minDelta = 0.1;
			springData.myInterval = 0;
			springData.finishFunction = killMe;
			_xController.startSpringing(springData);
			
			springData = new SpringData();
			springData.itemList = [_s];
			springData.myEasing = ease;
			springData.myDamping = damp;
			springData.startValue = null;
			springData.endValue = [y];
			springData.minSpeed = 0.1;
			springData.minDelta = 0.1;
			springData.myInterval = 0;
			springData.finishFunction = killMe;
			_yController.startSpringing(springData);
		}

	}
}
