﻿package com.nosuch {

	/**
	 * 	Midi event
	 */
	public class MidiEvent extends NthEvent {
				
		public static const NOTEON:String  			= "noteon";
		public static const NOTEOFF:String 			= "noteoff";
		public static const CONTROLLER:String		= "controller";
		public static const PROGRAM:String			= "program";
		public static const PRESSURE:String			= "pressure";
		public static const PITCHBEND:String		= "pitchbend";
		public static const CHANNELPRESSURE:String	= "channelpressure";
		public static const REALTIME:String			= "realtime";
		public static const SYSEX:String			= "sysex";
		
		public var deviceIndex:uint;
		public var midimsg:MidiMsg;
		
		public function MidiEvent(x:XML,tm:Number):void {
			var t:String = x.localName();
			if ( t.substring(0,5) == "midi_" ) {
				t = t.substring(5);
			} else {
				trace("HEY!  MidiEvent got a localName that doesn't start with midi_ !?");
			}
			fillFromXML(t,x);
			super(t,x,tm);
		}
		
		/**
		 * 	@constructor
		 */
		public function fillFromXML(t:String,x:XML):void {
			deviceIndex = x.attribute("devindex");
			var channel:uint = x.attribute("channel");
			if ( t == NOTEON ) {
				midimsg = new MidiNoteOn(channel,
							x.attribute("pitch"),
							x.attribute("velocity"));
			} else if ( t == NOTEOFF ) {
				midimsg = new MidiNoteOff(channel,
							x.attribute("pitch"),
							x.attribute("velocity"));
			} else if ( t == CONTROLLER ) {
				midimsg = new MidiController(channel,
							x.attribute("controller"),
							x.attribute("value"));
			} else if ( t == PROGRAM ) {
				midimsg = new MidiProgram(channel,
							x.attribute("value"));
			} else {
				trace("Unhandled MIDI event in fillFromXML t=",t);
			}
		}
	}
}
