﻿package com.nosuch
{
	import flash.utils.Dictionary;
	import flash.events.*;
	import flash.net.XMLSocket;

	public class NthClient extends EventDispatcher
	{
		private var _socket:XMLSocket;
		private var _count:int = 0;
		private static var instance:NthClient;
		private static var creating:Boolean = false;
		private static var fingers:Object = new Object();
	
		public function NthClient() {
			if ( !creating ) {
				throw new Error("Use NthClient.getInstance()!");
			}
			_socket = new XMLSocket;
			configureListeners();
			connect("localhost",1383);
			// _socket.connect("localhost", 1383);
		}
		public function connect(host:String,port:uint):void {
			_socket.connect(host,port);
		}
		public static function getInstance():NthClient {
			if ( !instance ) {
				creating = true;
				instance = new NthClient();
				creating = false;
			}
			return instance;
		}
		public function isConnected():Boolean {
			return _socket.connected;
		}
		
		public function configureListeners():void {
	        _socket.addEventListener(Event.CLOSE, closeHandler);
	        _socket.addEventListener(Event.CONNECT, connectHandler);
	        _socket.addEventListener(DataEvent.DATA, dataHandler);
	        _socket.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
	        _socket.addEventListener(ProgressEvent.PROGRESS, progressHandler);
	        _socket.addEventListener(SecurityErrorEvent.SECURITY_ERROR, securityErrorHandler);
	    }
	    public function closeHandler(event:Event):void {
	        trace("closeHandler: " + event);
	        dispatchEvent(new Event(Event.CLOSE));
	        removeListeners();
	    }
	    private function removeListeners():void {	        
	    	_socket.removeEventListener(Event.CLOSE, closeHandler);
	        _socket.removeEventListener(Event.CONNECT, connectHandler);
	        _socket.removeEventListener(DataEvent.DATA, dataHandler);
	        _socket.removeEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
	        _socket.removeEventListener(ProgressEvent.PROGRESS, progressHandler);
	        _socket.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, securityErrorHandler);
	    }
	
	    public function connectHandler(event:Event):void {
	    	trace("Connected to NthEvent server!");
	    	dispatchEvent(new Event(Event.CONNECT));
	        // socket.send('<connect uri="example.com/pie" user="tjt" />')
	        requestNextEvent();
	    }
	    
		public function send(s:String):void {
			_socket.send(s);
		}
		
	    public function requestNextEvent(overloaded:Boolean = false):void {
	     	// _socket.send("<next_event/>");
			if ( overloaded ) {
		     	this.send("<next_event overloaded=\"true\"/>");
		    } else {
		     	this.send("<next_event/>");
		    }

	    }
	
		private function dataHandler(event:DataEvent):void {
			// trace("data="+event.data);
	        var x:XML = new XML(event.data);
	        // trace("xml name="+x.name()+" localName="+x.name().localName);
	        if ( x.localName() == "event" ) {
				var tm:Number = x.attribute("time");
				// trace("DATAHANDLER tm=",tm);

	        	var c:XMLList = x.children()
				// trace("FingerEvent A");
	        	for each ( var i:XML in c ) {
	        		var s:String = i.localName();
					// trace("XML localName = ",s);
	        		if ( s.search("finger_") == 0 ) {
	        			var f:FingerEvent = new FingerEvent(i,tm);
						// trace("FingerEvent B");
	        			updateFingers(f);
	        			dispatchEvent(f);
					} else if ( s.search("midi_") == 0 ) {
						var m:MidiEvent = new MidiEvent(i,tm);
						dispatchEvent(m);
	        		} else {
	        			trace("Unrecognized event: "+s)
	        		}
	        	}
	        }
	       	requestNextEvent();
	    }

	    private function updateFingers(f:FingerEvent):void {
				fingers[f.fingerUID()] = new FingerState(f);
	    }
	    
	    public function getFingerStates():Object {
			return fingers;
	    }

	    public function ioErrorHandler(event:IOErrorEvent):void {
	        trace("ioErrorHandler: " + event);
	        if ( ! _socket.connected ) {
	        	trace("It's pretty likely that the NthServer isn't running...");
	        }
	    }
	
	    private function progressHandler(event:ProgressEvent):void {
	        trace("progressHandler loaded:" + event.bytesLoaded + " total: " + event.bytesTotal);
	    }
	
	    private function securityErrorHandler(event:SecurityErrorEvent):void {
	        trace("securityErrorHandler: " + event);
	    }
	}
}